<html lang="en" xlmns:th="http://www/thymleaf.org" xlmns:layout="http://ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{fragments/layout}">

<head>
	<title>Product API Pages</title>
</head>

<body>
	<div layout:fragment="content">
		<h1>PRODUCT API</h1>
		<br>
		<div class="form-outline mb-4">
			<input type="text" class="form-control" id="key" onkeyup="search(this.value.toLowerCase())"
				placeholder="Search">
		</div>
		<div class="p-3 mb-2 bg-primary text-white">
			<button type="button" class="btn btn-light" onclick="openModal()">
				Create New
			</button>
		</div>
		<div id="inputdata"></div>

		<script>
			$(function () {
				getAllProduct()
			})

			function getAllProduct() {
				$.ajax({
					url: '/api/product',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<table class='table' 'border=1'>"
						str += "<thead>"
						str += "<tr>"
						str += "<th>Category"
						str += "/Variants</th>"
						str += "<th>Initial</th>"
						str += "<th>Name</th>"
						str += "<th>Description</th>"
						str += "<th>Price</th>"
						str += "<th>Stock</th>"
						str += "<th style='text-align:center'>Active</th>"
						str += "<th colspan = '2' style='text-align:center'>Action</th>"
						str += "</tr>"
						str += "</thead>"
						str += "<tbody>"
						for (var i = 0; i < data.length; i++) {
							str += "<tr>"
							str += "<td>" + data[i].variants.category.categoryName + "/" + data[i].variants.name + "</td>"
							str += "<td>" + data[i].productInitial + "</td>"
							str += "<td>" + data[i].productName + "</td>"
							str += "<td>" + data[i].productDescription + "</td>"
							str += "<td>" + data[i].productPrice + "</td>"
							str += "<td>" + data[i].productStock + "</td>"
							str += "<td style='text-align:center'><input type='checkbox' name='isActive' checked disabled></td>"
							str += "<td style='text-align:center'><button class='btn btn-warning'; onclick='edit(" + data[i].id + ")';> Edit</button></td>"
							str += "<td style='text-align:center'><button class='btn btn-danger'; onclick='cekhapus(" + data[i].id + ")';> Delete </button></td>"
							str += "</tr>"
						}

						str += "</tbody>"
						str += "</table>"

						$('#inputdata').html(str)
					}
				})
			}

			function openModal() {
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<form>"
						str += "<input type='hidden' value=0 id='idproduct'>"
						str += "<div class='form-group'>"
						str += "<label>Category</label>"
						str += "<select class='form-control' id='categoryId' onchange='VariantByCategoryId(this.value)'>"
						str += "<option value =0>Pilih</option>"
						for (var i = 0; i < data.length; i++) {
							str += "<option value='" + data[i].id + "'>" + data[i].categoryName + "</option>"
						}
						str += "</select>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Variant</label>"
						str += "<select class='form-control' id='variantId'>"
						str += "</select>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Initial</label>"
						str += "<input type='text' class='form-control' id='productInitial'>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Name</label>"
						str += "<input type='text' class='form-control' id='productName'>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Description</label>"
						str += "<input type='text' class='form-control' id='productDescription'>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Price</label>"
						str += "<input type='number' class='form-control' id='productPrice'>"
						str += "</div>"
						str += "<div class='form-group'>"
						str += "<label>Stock</label>"
						str += "<input type='number' class='form-control' id='productStock'>"
						str += "</div>"
						str += "<div class='form-group form-check'>"
						str += "<input type='checkbox' class='form-check-input' id='isActive'>"
						str += "<label class='form-check label'>Active</label>"
						str += "</form>"

						$('.modal-title').html('Product Form')
						$('.modal-body').html(str)
						$('#btn-save').off('click').on('click', save).html('Create').addClass("btn btn-success")
						$('#modal').modal('show')
					}
				})
			}

			function VariantByCategoryId(categoryId, variantId) {
				console.log(categoryId)
				$.ajax({
					url: '/api/variantsbycategory/' + categoryId + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<option>Pilih</option>"
						for (var i = 0; i < data.length; i++) {
							if (data[i].id == variantId) {
								select = "selected";
							} else {
								select = "";
							}
							str += "<option value='" + data[i].id + "'" + select + ">" + data[i].name + "</option>"
						}
						$('#variantId').html(str)
					}
				})
			}

			function save() {
				var idvar = $('#variantId').val()
				var id = $('#idproduct').val()
				var initial = $('#productInitial').val()
				var name = $('#productName').val()
				var des = $('#productDescription').val()
				var pr = $('#productPrice').val()
				var st = $('#productStock').val()
				var active = $('#isActive')[0].checked


				var alldata = '{'
				alldata += '"productInitial":"' + initial + '",'
				alldata += '"productName":"' + name + '",'
				alldata += '"productDescription":"' + des + '",'
				alldata += '"productPrice":"' + pr + '",'
				alldata += '"productStock":"' + st + '",'
				alldata += '"isActive":"' + active + '",'
				alldata += '"variantId":' + idvar + ''
				alldata += '}'

				var link = ''
				var type = ''
				if (id == 0) {
					link = '/api/product/add'
					type = 'post'
				} else {
					link = '/api/edit/product/' + id + ''
					type = 'put'
				}

				$.ajax({
					url: link,
					type: type,
					contentType: 'application/json',
					data: alldata,
					success: function () {
						$('#modal').modal('toggle')
						getAllProduct()
					}

				})
			}

			function edit(id) {
				openModal()
				$.ajax({
					url: '/api/product/' + id + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						$('#idproduct').val(data.id)
						$('#categoryId').val(data.variants.category.id)
						VariantByCategoryId(data.variants.category.id, data.variantId)
						$('#productInitial').val(data.productInitial)
						$('#productName').val(data.productName)
						$('#productDescription').val(data.productDescription)
						$('#productPrice').val(data.productPrice)
						$('#productStock').val(data.productStock)
						$('#isActive').prop("checked", true)
						$('.modal-title').html('Edit')
						$('#btn-save').html('Save Change').addClass("btn btn-warning")
					}
				})
			}

			function cekhapus(id) {
				openModal()
				$.ajax({
					url: '/api/product/' + id + '',
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						var str = "<form>"
						str += "<label>Are you sure you want to delete this?</label><br>"
						str += "<input type='hidden' value='" + id + "'id='idproduct'>"
						str += "<table>"
						str += "<tr>"
						str += "<td style='text-align :right'>Category</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data.variants.category.categoryName + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Variant</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data.variants.name + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align : right'>Initial</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align : left'>" + data.productInitial + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Name</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'>" + data.productName + "</td>"
						str += "</tr>"
						str += "<tr>"
						str += "<td style='text-align :right'>Active</td>"
						str += "<td style='width:20px'></td>"
						str += "<td style='text-align :left'><input checked type='checkbox' id='isActive' disabled></td>"
						str += "</tr>"
						str += "</table>"
						str += "</form>"

						$('.modal-title').html('Edit')
						$('.modal-body').html(str)
						$('#btn-save').off('click').on('click', hapus).html('Delete').addClass("btn btn-danger")
						$('#modal').modal('show')
					}
				})
			}

			function hapus() {
				var idvar = $('#variantId').val()
				var id = $('#idproduct').val()
				var initial = $('#productInitial').val()
				var name = $('#productName').val()
				var des = $('#productDescription').val()
				var pr = $('#productPrice').val()
				var st = $('#productStock').val()
				var active = $('#isActive')[0].checked

				var alldata = '{'
				alldata += '"productInitial":"' + initial + '",'
				alldata += '"productName":"' + name + '",'
				alldata += '"productDescription":"' + des + '",'
				alldata += '"productPrice":"' + pr + '",'
				alldata += '"productStock":"' + st + '",'
				alldata += '"isActive":"' + active + '",'
				alldata += '"variantId":' + idvar + ''
				alldata += '}'

				$.ajax({
					url: '/api/delete/product/' + id + '',
					type: 'put',
					contentType: 'application/json',
					data: alldata,
					success: function () {
						$('#modal').modal('toggle')
						getAllProduct()
					}
				})
			}

			function search(key) {
				if (key.length != 0) {
					$.ajax({
						url: '/api/search/product/' + key + '',
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							var str = "<table class='table' 'border=1'>"
							str += "<thead>"
							str += "<tr>"
							str += "<th>Category"
							str += "/Variants</th>"
							str += "<th>Initial</th>"
							str += "<th>Name</th>"
							str += "<th>Description</th>"
							str += "<th>Price</th>"
							str += "<th>Stock</th>"
							str += "<th style='text-align:center'>Active</th>"
							str += "<th colspan = '2' style='text-align:center'>Action</th>"
							str += "</tr>"
							str += "</thead>"
							str += "<tbody>"
							for (var i = 0; i < data.length; i++) {
								str += "<tr>"
								str += "<td>" + data[i].variants.category.categoryName + "/" + data[i].variants.name + "</td>"
								str += "<td>" + data[i].productInitial + "</td>"
								str += "<td>" + data[i].productName + "</td>"
								str += "<td>" + data[i].productDescription + "</td>"
								str += "<td>" + data[i].productPrice + "</td>"
								str += "<td>" + data[i].productStock + "</td>"
								str += "<td style='text-align:center'><input type='checkbox' name='isActive' checked disabled></td>"
								str += "<td style='text-align:center'><button class='btn btn-warning'; onclick='edit(" + data[i].id + ")';> Edit</button></td>"
								str += "<td style='text-align:center'><button class='btn btn-danger'; onclick='cekhapus(" + data[i].id + ")';> Delete </button></td>"
								str += "</tr>"
							}

							str += "</tbody>"
							str += "</table>"

							$('#inputdata').html(str)
						}
					})
				} else {
					getAllProduct()
				}

			}
		</script>
	</div>
</body>

</html>